;> *************************************
;> * MASTER BOOT RECORD (MBR) DI WIN95 *
;> *************************************
;> M.Campinoti 05/12/99
;> DISASSEMBLATO CON NDISASM 0.94
;> LUNGHEZZA DEL CODICE 138 BYTES (0x8A) (NON SI SONO CERTO SPRECATI...)
;> NEL BOOT SI PUO' ARRIVARE AL MASSIMO A 446 BYTES (0x1BE) DI CODICE.
;>
;> FORMATO DEL Master Boot Sector:
;> Offset	Size		Description	
;> 00h 		446 BYTEs	Master bootstrap loader code
;>1BEh 		16 BYTEs	partition record for partition 1 
;>1CEh 		16 BYTEs	partition record for partition 2
;>1DEh 		16 BYTEs	partition record for partition 3
;>1EEh 		16 BYTEs	partition record for partition 4
;>1FEh		1 WORD		signature, AA55h indicates valid boot block

00000000  FA      	    cli			;INT() DISABILITATI
00000001  33C0              xor ax,ax		;AZZERA AX
00000003  8ED0              mov ss,ax		;AZZERA SS
00000005  BC007C            mov sp,0x7c00	;SP=0x7C00
00000008  8BF4              mov si,sp		;SI=0x7C00
0000000A  50                push ax		;mette 0x00 sullo stack	
0000000B  07                pop es		;ES=0x00
0000000C  50                push ax		;mette 0x00 sullo stack
0000000D  1F                pop ds		;DS=0x00
0000000E  FB                sti			:ABILITA GLI INT()

;> QUI INIZIA UN CICLO CHE COPIA 256 WORD DA 0000:7C00 A 0000:0600
;> CIOE'"RILOCA" IL PRIMO SETTORE IN 0:0600 E LO ESEGUE DA LI' INVECE
;> CHE DA 0:7C00 COME FACEVA IL DOS.
;> ---------------------------------
;> MOVSW DS:SI -> ES:DI
;> DS:SI = 0000:7C00
;> ES:DI = 0000:0600
;> ---------------------------------

0000000F  FC                cld			;AZZERA IL DIRECTION FLAG
00000010  BF0006            mov di,0x600	;DI=0x600
00000013  B90001            mov cx,0x100	;CX=0x100
00000016  F2A5              repne movsw		;COPIA WORD

00000018  EA1D060000        jmp 0x0:0x61d	;SALTA DOVE A COPIATO

;> PRATICAMENTE ORA IL CODICE DEL MBR  CARICATO IN MEMORIA ALL'INDIRIZZO
;> 0000:0600 E SI PARTE CON OFFSET 0x1D , CIOE' DA QUI.....

0000001D  BEBE07            mov si,0x7be	;SI=0x7BE
00000020  B304              mov bl,0x4		;BL=0x04 (CERCA LA PRIMA DELLE QUATTRO 
						;PARTIZIONI ATTIVE)

;> PUNTA NELLA ZONA DI MEMORIA ORIGINALE CON OFFSET 0xBE E COMINCIA A CERCARE
;> VALORI Ox80 OPPURE 0x00, CERCA UNA PARTIZIONE ATTIVA SULL'HD PER BOOTARE DA LI'
;> (IL FLAG DI PARTIZIONE ATTIVA E' BootFlag = 0x80)
;> QUINDI A PARTIRE DA OFFSET 0xBE SI TROVA LA PARTITION TABLE
;> LA STRUTTURA DELLA TABELLA E' QUESTA (SIZE = 16 BYTES)
;>
;>	struc	PT_ENT		;Partition table entry 
;>BootFlag	  resb	1
;>BeginHead       resb	1
;>BeginSector     resb	1
;>BeginCyl        resb	1
;>SystemID        resb	1	;ESEMPIO 0x83=LinuxNative 0x07=WindowsNT etc...
;>EndHead         resb	1
;>EndSector       resb	1
;>EndCyl          resb	1
;>RelSectorLow    resw	1
;>RelSectorHigh   resw	1
;>NumSectorsLow   resw	1
;>NumSectorsHigh  resw	1
;>	endstruc

00000022  803C80            cmp byte [si],0x80	;CONFRONTA IL BYTE PUNTATO DA [SI] CON 0x80...
00000025  740E              je 0x35		;SE UGUALE SALTA A 00000035
00000027  803C00            cmp byte [si],0x0	;CONFRONTA IL BYTE PUNTATO DA [SI] CON 0x00...
0000002A  751C              jne 0x48		;SE NON UGUALE SALTA A 00000048
0000002C  83C610            add si,byte +0x10	;SI=SI+0x10 (SALTA IN AVANTI DI UNA STRUCT PT_ENT)
0000002F  FECB              dec bl		;DECREMENTA BL..
00000031  75EF              jne 0x22		;SE BL!=0 TORNA A INIZIO CICLO
00000033  CD18              int 0x18		;ALTRIMENTI INT 0x18 (DISKLESS BOOT HOOK)
						;CHIAMATO QUANDO NEL SISTEMA NON C'E' UN DISCO
						;BOOTABILE ! (99 SU 100 BLOCCA TUTTO...)

;> QUI CI SALTA SE HA TROVATO UN VALORE 0x80 (LA PARTIZIONE IN ESAME E' QUELLA ATTIVA)
00000035  8B14              mov dx,[si]		;DX=0x80 (VALORE CHE INDICA PARTIZIONE ATTIVA)
00000037  8B4C02            mov cx,[si+0x2]	;CX=CONTENUTO DELL'INDIRIZZO DUE BYTE 								;AVANTI (BeginSector) SERVE POI PER CARICARE IL
						;SETTORE CON INT 0x13
0000003A  8BEE              mov bp,si		;BP=INDIRIZZO DOVE HA TROVATO 0x80

0000003C  83C610            add si,byte +0x10	;SI=SI+0x10 (SALTA IN AVANTI DI UNA STRUCT PT_ENT)
0000003F  FECB              dec bl		;BL=BL-1
00000041  741A              je 0x5d		;SE BL==0 ALLORA SALTA A 0000005D
00000043  803C00            cmp byte [si],0x0	;CONFRONTA IL BYTE PUNTATO DA [SI] CON 0x00
00000046  74F4              je 0x3c		;SALTA A 0000003C SE E' UGUALE A ZERO

;> QUI CI SALTA SE HA TROVATO UN VALORE 0x00...
00000048  BE8B06            mov si,0x68b	;SI=0x068B 
						;(PUNTA A STRINGA "INVALID PARTITION TABLE")

0000004B  AC                lodsb		;CARICA UN BYTE DA DS:SI (0000:068B) IN AL
0000004C  3C00              cmp al,0x0		;FIN QUANDO NON TROVA LO ZERO DI "FINESTRINGA"
0000004E  740B              je 0x5b		;SE LO TROVA SALTA A 0000005B (LOOP INFINITO)
00000050  56                push si		;ALTRIMENTI PUSH SI
00000051  BB0700            mov bx,0x7		;BX=0x07
00000054  B40E              mov ah,0xe		;AH=0x0E
00000056  CD10              int 0x10		;INT 0x10 (STAMPA CARATTERE)
00000058  5E                pop si		;RIPRISTINA SI
00000059  EBF0              jmp short 0x4b	;E CARICA IL PROSSIMO CARATTERE DA STAMPARE

;>EVIDENTEMENTE STAMPA UN MESSAGGIO DI ERRORE, PERCHE' UNA VOLTA FINITO IL CICLO
;>SI PIANTA IN QUESTO LOOP INFINITO (SALTA SU SE STESSO!)

0000005B  EBFE              jmp short 0x5b	;LOOP INFINITO

;>SE HA TROVATO LA PARTIZIONE ATTIVA ALLORA E' FELICE, E RIPARTE DA QUI..
;>VEDI IL CODICE PRECEDENTE DOVE C'E' UN SALTO A QUESTA LOCAZIONE.
;>QUI CARICA UN SETTORE A PARTIRE DA 0000:7C00

0000005D  BF0500            mov di,0x5		;DI=0x05 (5 TENTATIVI DI LETTURA PRIMA DI ABORTIRE)	
00000060  BB007C            mov bx,0x7c00	;BX=0x7C00 (BUFFER DOVE SCARICARE IL SETTORE)
00000063  B80102            mov ax,0x201	;AX=0x0201 (01 INDICA "LEGGI N1 SETTORE")
00000066  57                push di		;SALVA DI SULLO STACK (0x05)
00000067  CD13              int 0x13		;INT 0x13 (LEGGE UN SETTORE)
00000069  5F                pop di		;RIPRISTINA DI
0000006A  730C              jae 0x78		;SALTA SE "ABOVE OR EQUAL" (LETTURA CORRETTA)
0000006C  33C0              xor ax,ax		;ALTRIMENTI AZZERA AX 
						;(C'E' STATO UN ERRORE DI LETTURA)
0000006E  CD13              int 0x13		;E RICHIAMA INT 0x13 (RILEGGE IL SETTORE)
00000070  4F                dec di		;DECREMENTA DI
00000071  75ED              jne 0x60		;E SALTA A 00000060

00000073  BEA306            mov si,0x6a3	;SI=06A3 
						;(PUNTA A STRINGA "ERROR LOADING OPERATING SYSTEM")	
00000076  EBD3              jmp short 0x4b	;STAMPA UN MESSAGGIO DI ERRORE

;> LA LETTURA DEL SETTORE E' ANDATA A BUON FINE,CONTINUIAMO L'AVVENTURA....

00000078  BEC206            mov si,0x6c2	;SI=0x06C2 
						;(PUNTA A STRINGA "MISSING OPERATING SYSTEM")

0000007B  BFFE7D            mov di,0x7dfe	;DI=0x7DFE
0000007E  813D55AA          cmp word [di],0xaa55;CONFRONTA LA WORD CON "VALID BOOT BLOCK" 0xAA55
00000082  75C7              jne 0x4b		;SE NON E' VALIDO STAMPA UN MESSAGGO DI ERRORE 
00000084  8BF5              mov si,bp		;ALTRIMENTI SI=BP 
						;(L'INDIRIZZO DOVE HA TROVATO 0x80)
00000086  EA007C0000        jmp 0x0:0x7c00	;E INIZIA AD ESEGUIRE QUELLO CHE HA CARICATO !

;> DA QUI IN POI NON E' CODICE, MA SONO DATI CHE USA IL MBR, TRA CUI ANCHE
;> LE STRINGHE (SONO TRE) DEI MESSAGGI DI ERRORE.

;> STRINGA UNO START ("INVALID PARTITION TABLE")
0000008B  49                dec cx
0000008C  6E                outsb
0000008D  7661              jbe 0xf0
0000008F  6C                insb
00000090  6964207061        imul sp,[si+0x20],0x6170
00000095  7274              jb 0x10b
00000097  6974696F6E        imul si,[si+0x69],0x6e6f
0000009C  207461            and [si+0x61],dh
0000009F  626C65            bound bp,[si+0x65]
;>STRINGA UNO STOP (MARCA LA FINE LO 0x00 DELLA RIGA SUCCESSIVA)

;>STRINGA DUE START ("ERROR LOADING OPERATING SYSTEM")
000000A2  004572            add [di+0x72],al
000000A5  726F              jb 0x116
000000A7  7220              jb 0xc9
000000A9  6C                insb
000000AA  6F                outsw
000000AB  61                popa
000000AC  64696E67206F      imul bp,[fs:bp+0x67],0x6f20
000000B2  7065              jo 0x119
000000B4  7261              jb 0x117
000000B6  7469              je 0x121
000000B8  6E                outsb
000000B9  67207379          and [ebx+0x79],dh
000000BD  7374              jae 0x133
000000BF  656D              gs insw
;>STRINGA DUE STOP (MARCA LA FINE LO 0x00 DELLA RIGA SUCCESSIVA)

;>STRINGA TRE START ("MISSING OPERATING SYSTEM")
000000C1  004D69            add [di+0x69],cl
000000C4  7373              jae 0x139
000000C6  696E67206F        imul bp,[bp+0x67],0x6f20
000000CB  7065              jo 0x132
000000CD  7261              jb 0x130
000000CF  7469              je 0x13a
000000D1  6E                outsb
000000D2  67207379          and [ebx+0x79],dh
000000D6  7374              jae 0x14c
000000D8  656D              gs insw
;>STRINGA TRE STOP (MARCA LA FINE LO 0x00 DELLA RIGA SUCCESSIVA)

000000DA  0000              add [bx+si],al
000000DC  801312            adc byte [bp+di],0x12
000000DF  150000            adc ax,0x0
000000E2  0000              add [bx+si],al
000000E4  0000              add [bx+si],al
........
........
000001BC  0000              add [bx+si],al

;> DA QUI INIZIA LA PARTITION TABLE (IN QUESTO CASO DELL'HD DEL MIO UFFICIO..)
;> LA STRUTTURA DEI DATI DI OGNI ENTRY E' ALL'INIZIO DI QUESTO STESSO FILE.

000001BE  800101            add byte [bx+di],0x1
000001C1  00067FBF          add [0xbf7f],al
000001C5  07                pop es
000001C6  3F                aas
000001C7  0000              add [bx+si],al
000001C9  00C1              add cl,al
000001CB  FB                sti
000001CC  3F                aas
000001CD  0000              add [bx+si],al
000001CF  00810805          add [bx+di+0x508],al
000001D3  7FFF              jg 0x1d4
000001D5  0E                push cs
000001D6  00FC              add ah,bh
000001D8  3F                aas
000001D9  00805C20          add [bx+si+0x205c],al
000001DD  0000              add [bx+si],al
000001DF  0000              add [bx+si],al
000001E1  0000              add [bx+si],al
000001E3  0000              add [bx+si],al
000001E5  0000              add [bx+si],al
000001E7  0000              add [bx+si],al
000001E9  0000              add [bx+si],al
000001EB  0000              add [bx+si],al
000001ED  0000              add [bx+si],al
000001EF  0000              add [bx+si],al
000001F1  0000              add [bx+si],al
000001F3  0000              add [bx+si],al
000001F5  0000              add [bx+si],al
000001F7  0000              add [bx+si],al
000001F9  0000              add [bx+si],al
000001FB  0000              add [bx+si],al

;> MARCATORE DI "VALID BOOT BLOCK" 0x55AA

000001FD  0055AA            add [di-0x56],dl

